#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "..\INCLUDE\common.h"


//Test---------------------------------------
//-------------------------------------------
void quit(char* str, ...) {
va_list args;
	va_start(args, str);
	vprintf(str, args);
	va_end(args);
	XOBJECT_UNINITIALIZE;
	exit(0);
}
int main(int argc, char** argv) {
int i, size, pos, dpos, sz;
FILE* f;
char* data, *str;
int size1;
char* data1;
XObject* o, *o1;

	XObject::setLogLevel(-1);
	XOBJECT_INITIALIZE;
	o = XObject::getInstance("string", "s");
	o->setStringSize(256);
	for (i=0; i<256; i++) {
		o->getStringValue()[i] = i;
	}
	LOGOBJ(o);
	delete o;

	if (argc<2) quit("Usage: %s <filename>\n", argv[0]);
	XObject::loadClasses(argv[1]);
	if (argc>2) {
		o = XObject::loadObject(argv[2]);
		LOGOBJ(o);
		XObject::saveObject(argv[2], o);
		delete o;
	}
	XObject::loadFile(argv[1], &data, &size);
	pos = 0;
	while (pos<size) {
		o = XObject::getInstanceText(data, &pos);
		if (!o) quit("Syntax error on: %d", pos);
		printf("(%s) %s loaded\n", o->getClassName(), o->getName());
		LOGOBJ(o);
/*
		LOGOBJ(o->getValue());
//		o->flagClear(FLAGS_TEXT);
		XObject::saveObject(o->getName(), o);
		o1 = XObject::loadObject(o->getName());
		if (!o1) quit("unable to reload %s", o->getName());
		LOGOBJ(o1);
		delete o1;
*/
		delete o;

	}
	quit("Bye");
}

